function defactf(arg1,arg2,arg3,arg4)
%DEFACTF  De-factorization of a transfer function (TFI).
%   DEFACTF,gi,gj - from TFI [DEFACTF('gi','gj') - from Matlab]
%   saves in gj the polynomial form of gi.
%   If DEFACTF is called without arguments, gi and gj can be specified
%   in interactive mode.

% TFI Environment (A.Civolani & G.Marro) - 1994-96.

if nargin==0
 gi=input('   enter transfer function gi (input) : ','s');
 if isempty(gi), return, end
 if gi=='0', return, end
 if ~exist([gi,'.mat'])
  disp([' **** error: ',gi,'.mat does not exist']), return
 end
 gj=input('   enter transfer function gj (output) : ','s');
 if isempty(gj), return, end
 if gj=='0', return, end
elseif nargin>=2
 if ~exist([arg1,'.mat'])
  disp([' **** error: ',arg1,'.mat does not exist'])
  return
 else
  gi=arg1; gj=arg2;
 end
else
 disp(' **** error: not enough input arguments')
 return
end
[num,den,str]=exportf(gi,1); if isempty(den), return, end
tfg(gi)
if str=='s'
 aa=importf(num,den,gj);
else
 aa=importf(num,den,gj,1);
end
if aa==1, tfg(gj), end
% --- last line of defactf ---
