function [out1,fl]=functab(arg1,arg2)
%   A function table for shorthand notation (aux for TFI).

% TFI Environment (A.Civolani & G.Marro) - 1994-96.

fl=0; if length(arg1)<3, out1=arg1; return, end
st=arg1(1:3);
if st=='con', out1='convert'; fl=1;
mess='conversion from continuous to discrete'; end
if st=='des', out1='descrf'; fl=1;
mess='nonlinear system analysis by means of the describing function'; end
if st=='dpo', out1='dpopov'; fl=1;
mess='Popov plot'; end
if st=='fac', out1='factf'; fl=1;
mess='factorization with interactive selection of multiplicity'; end
if st=='fir', out1='firtf'; fl=1;
mess='synthesis of a FIR'; end
if st=='fre', out1='fresp'; fl=1;
mess='frequency response'; end
if st=='gpm', out1='gpmarg'; fl=1;
mess='gain and phase margins'; end
if st=='inv', out1='invtr'; fl=1;
mess='inverse Laplace or Z transform'; end
if st=='lag', out1='lagc'; fl=1;
mess='interactive design of a lag compensator'; end
if st=='lea', out1='leadc'; fl=1;
mess='interactive design of a lead compensator'; end
if st=='ord', out1='ordf'; fl=1;
mess='ordering figures'; end
if st=='mak', out1='makeleg'; fl=1;
mess='creates or cleans a legend in the last figure'; end
if st=='nls', out1='nlsim'; fl=1;
mess='time response of a feedback system with a nonlinear element'; end
if st=='per', out1='perftra'; fl=1;
mess='design of a perfect tracking digital feedforward unit'; end
if st=='res', out1='resfiglo'; fl=1;
mess='reset figure locations to default'; end
if st=='rob', out1='robpar'; fl=1;
mess='analysis of stability robustness versus parametric variations'; end
if st=='roo', out1='rootl'; fl=1;
mess='root locus'; end
if st=='rou', out1='routh'; fl=1;
mess='stability intervals with the Routh criterion'; end
if st=='sam', out1='samptime'; fl=1;
mess='sampling time'; end
if st=='sel', out1='select'; fl=1;
mess='interactive selection of factors'; end
if st=='sta', out1='startint'; fl=1;
mess='definition of some TFI settings'; end
if st=='tfe', out1='tfeval'; fl=1;
mess='evaluation of a transfer function in the complex field'; end
if st=='tre', out1='tresp'; fl=1;
mess='time response'; end
if st=='wpl', out1='wplane'; fl=1;
mess='conversion s-to-z or z-to-s according the w-plane equivalence'; end
if st=='zpp', out1='zpplots'; fl=1;
mess='zero-pole map'; end
if (fl==0)&(length(arg1)<4), out1=arg1; return, end
if fl~=0, st='xxxx'; else, st=arg1(1:4); end
if st=='defa', out1='defactf'; fl=1;
mess='conversion to the polynomial form'; end
if st=='deft', out1='deftf'; fl=1;
mess='definition of some special transfer functions'; end
if st=='delf', out1='delf'; fl=1;
mess='deletes all the current figures'; end
if st=='pidc', out1='pidc'; fl=1;
mess='interactive design of a PID regulator'; end
if st=='pidd', out1='pidd'; fl=1;
mess='interactive design of a digital PID regulator'; end
if st=='pidn', out1='pidnich'; fl=1;
mess='PD, PI or PID regulator design with the Nichols diagram'; end
if st=='regd', out1='regdph'; fl=1;
mess='design of a regulator with closed-loop pole assignment'; end
if st=='comp', out1='compbode'; fl=1;
mess='lag or lead compensator design with the Bode diagrams'; end
if st=='regn', out1='regnich'; fl=1;
mess='compensator design with the Nichols diagram'; end
if st=='regr', out1='regrootl'; fl=1;
mess='compensator design with the root locus'; end
if fl==0, out1=arg1; return, end
if ~(strcmp(arg1,out1))&(nargin==2)
 fprintf(['   ',out1]), fprintf(' ('), fprintf(mess), fprintf(')\n')
end
% --- last line of functab ---
