function gridmng(arg)
%GRIDMNG  Grid management and other functions for uicontrol.

% TFI Environment (A.Civolani & G.Marro) - 1994-96.

global pbs ABIL gr flg1 fleg nfig nfig1 HA str VV0 VV GG PP HALEG LABLEG

if arg==1
 if gr==0
  gr=1; grid on
 else
  gr=0; grid off
 end
elseif arg==2
 if flg1~=4
  if gr==0
   gr=1; grid on
  else
   gr=0; grid off
  end
 else
  if fleg==1, eval('legend off'), end
  subplot(2,1,1), axis(GG)
  if fleg==1, eval(['legend(HALEG,',LABLEG,')']), end
  if gr==0, grid on, else, grid off, end
  hold off
  subplot(2,1,2), axis(PP)
  if gr==0
   gr=1; grid on
  else
   gr=0; grid off
  end
  hold off, figure(gcf)
 end
elseif arg==3
 if ABIL==1
  figure(nfig1), pause(2)
  figure(nfig)
 end
elseif arg==4
 if length(HA)==0
  HA=rgrid;
 else
  for kk=1:length(HA), eval('delete(HA(kk))','err=1;'), end
  HA=[];
 end
elseif arg==5
 if strcmp(str,'s')
  if length(HA)==0
   HA=rgrid; zoom off
  else
   for kk=1:length(HA), eval('delete(HA(kk))','err=1;'), end
   HA=[];
  end
 else
  if length(HA)==0
   HA=drgrid; zoom off
  else
   for kk=1:length(HA), eval('delete(HA(kk))','err=1;'), end
   HA=[];
  end
 end
elseif arg==6
 subplot(2,1,1), grid
 subplot(2,1,2), grid
elseif arg==7
 set(gca,'XTickMode','auto'), set(gca,'YTickMode','auto')
 zoom
elseif arg==8
 subplot(2,1,1)
 set(gca,'XTickMode','auto'), set(gca,'YTickMode','auto')
 subplot(2,1,2)
 set(gca,'XTickMode','auto'), set(gca,'YTickMode','auto')
 zoom
elseif arg==9
 xsca=get(gca,'Xscale');
 titl=get(get(gca,'Title'),'String');
 xla=get(get(gca,'Xlabel'),'String');
 yla=get(get(gca,'Ylabel'),'String');
 reset(gca)
 set(gca,'Xscale',xsca,'Box','on')
 title(titl), xlabel(xla), ylabel(yla), VV=axis;
 if gr==1, grid on, end
 zoom
elseif arg==10
 subplot(2,1,1)
 titl=get(get(gca,'Title'),'String');
 xla=get(get(gca,'Xlabel'),'String');
 yla=get(get(gca,'Ylabel'),'String');
 reset(gca)
 set(gca,'Xscale','log','Box','on')
 title(titl), xlabel(xla), ylabel(yla), GG=axis;
 if gr==1, grid on, end
 subplot(2,1,2)
 titl=get(get(gca,'Title'),'String');
 xla=get(get(gca,'Xlabel'),'String');
 yla=get(get(gca,'Ylabel'),'String');
 reset(gca)
 set(gca,'Xscale','log','Box','on')
 title(titl), xlabel(xla), ylabel(yla), PP=axis;
 if gr==1, grid on, end
 zoom
elseif arg==11
 xsca=get(gca,'Xscale');
 titl=get(get(gca,'Title'),'String');
 xla=get(get(gca,'Xlabel'),'String');
 yla=get(get(gca,'Ylabel'),'String');
 reset(gca), axis(VV)
 set(gca,'Xscale',xsca,'Box','on')
 title(titl), xlabel(xla), ylabel(yla)
 if gr==1, grid on, end
 zoom
elseif arg==13
 if pbs(85)==0
  pbs(85)=1; grid on
 else
  pbs(85)=0; grid off
 end
elseif arg==14
 if pbs(86)==0
  pbs(86)=1;
  subplot(2,1,1), grid on
  subplot(2,1,2), grid on
 else
  pbs(86)=0;
  subplot(2,1,1), grid off
  subplot(2,1,2), grid off
 end
end
if arg==25
 TT1=VV0; TT1(2)=TT1(2)/2+10^(-6)*(TT1(2)/2-TT1(1)); VV=TT1; axis(VV)
 set(gca,'XTickMode','auto'), xtk=get(gca,'xtick');
 VV(2)=xtk(length(xtk)); axis(VV); drawnow
elseif arg==26
 TT1=VV0; TT1(2)=TT1(2)/5+10^(-6)*(TT1(2)/5-TT1(1)); VV=TT1; axis(VV)
 set(gca,'XTickMode','auto'), xtk=get(gca,'xtick');
 VV(2)=xtk(length(xtk)); axis(VV); drawnow
elseif arg==27
 TT1=VV0; TT1(2)=TT1(2)/10+10^(-6)*(TT1(2)/10-TT1(1)); VV=TT1; axis(VV)
 set(gca,'XTickMode','auto'), xtk=get(gca,'xtick');
 VV(2)=xtk(length(xtk)); axis(VV); drawnow
elseif arg==28
 TT1=VV0; TT1(2)=TT1(2)+10^(-6)*(TT1(2)-TT1(1)); VV=TT1; axis(VV), drawnow
 set(gca,'XTickMode','auto'), drawnow
end
% --- last line of gridmng ---
