function invtr(arg1,arg2,arg3,arg4)
%INVTR	  Inverse Laplace or Z transform (TFI).
%   INVTR,gi - from TFI [INVTR('gi') - from Matlab] provides the inverse
%   Laplace or Z transform of transfer function gi.
%   The following options are available for complex modes:
%      1 - complex modes in Cartesian form
%      2 - complex modes in polar form (function sine)
%      3 - complex modes in polar form (function cosine)
%   If INVTR is called without argument, transfer function gi can be
%   specified in interactive mode.

% TFI Environment (A.Civolani & G.Marro) - 1994-96.

if nargin>0
 if ~exist([arg1,'.mat'])
  disp([' **** error: ',arg1,'.mat does not exist']), return
 else
  gi=arg1;
 end
else
 gi=input('   enter transfer function: ','s');
 if isempty(gi), return, end
 if ~exist([gi,'.mat'])
  disp([' **** error: ',gi,'.mat does not exist']), return
 end
end
[z,p,k,str]=exportf(gi,1); if isempty(k), return, end
if length(z)>length(p)
 disp([' **** error: m > n in ',gi]), return
end
flg=1;
rop=(length(p)~=0)&(norm(imag(p))>0);
if rop
 flg=0;
 while (flg~=1)&(flg~=2)&(flg~=3)
  fprintf('\n')
  disp('   1 - complex modes in Cartesian form')
  disp('   2 - complex modes in polar form - function sine')
  disp('   3 - complex modes in polar form - function cosine')
  flg=input('   your choice : ');
  if length(flg)==0, flg=0; end
 end
end
typ=flg;
if str=='s'
 invtrc(z,p,k,typ,gi)
else
 invtrd(z,p,k,typ,gi)
end
% --- last line of invtr ---
