function [Nparc_rr,Dparc_rr,Kparc_rr,err_rr]=tfpar(parNc_rr,...
  parDc_rr,parkc_rr,matparc_rr,valuepc_rr)
%   TFPAR Computation of a parametric transfer function (aux for TFI).
%   [Nparc,Dparc,Kparc]=tfpar(parNc,parDc,parkc,matparc,valuepc).

% TFI Environment (A.Civolani & G.Marro) - 1994-96.

lmat_rr=size(matparc_rr); err_rr=0;
for i_rr=1:lmat_rr(1)
 eval([matparc_rr(i_rr,:),'=',sprintf('%.15e',valuepc_rr(i_rr)),';']);
end
eval(['Kparc_rr=',parkc_rr,';'],'err_rr=1;');
if err_rr==1
 fprintf('\n ERROR: illegal parametric expression for the gain !!\n')
 return
end
ssn_rr=size(parNc_rr); ssd_rr=size(parDc_rr);
Nparc_rr=[]; Dparc_rr=[];
for i_rr=1:ssn_rr(1)
 eval(['vsn_rr=[',parNc_rr(i_rr,:),'];'],'err_rr=2;')
 if err_rr==2
  fprintf('\n ERROR: illegal parametric expression in numerator ')
  fprintf('(factor %.4g) !!\n',i_rr)
  return
 end
 Nparc_rr=[Nparc_rr;vsn_rr];
end
for i_rr=1:ssd_rr(1)
 eval(['vsd_rr=[',parDc_rr(i_rr,:),'];'],'err_rr=3;')
 if err_rr==3
  fprintf('\n ERROR: illegal parametric expression in denominator ')
  fprintf('(factor %.4g) !!\n',i_rr)
  return
 end
 Dparc_rr=[Dparc_rr;vsd_rr];
end
% --- last line of tfpar ---
