function zpplots(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)
%ZPPLOTS  Zero-pole layout drawing (TFI).
%   ZPPLOTS,gi - from TFI [ZPPLOTS('gi') - from Matlab] plots the zeros
%   and poles of transfer function gi.
%   Up to 4 tf's can be plotted with different colors.

% TFI Environment (A.Civolani & G.Marro) - 1994-96.

global ABIL TRF1 TRF2 TRF3 TRF4 HA str HALEG FIGLEG LABLEG SUBPLEG

if exist('legen#.mat'), load legen#, else, legen=0; islegen=0; end
[vcol1,vcol2,repco]=coltbl; ABIL=0; HALEG=[]; LABLEG=[]; SUBPLEG=0;
frame=.1; str='s'; HA=[];
nargs=nargin;
if nargs==0
 arg1=input('   enter transfer function : ','s');
 if isempty(arg1), return, end
 if ~exist([arg1,'.mat'])
  disp([' **** error: ',g1,'.mat does not exist']), return
 else
  nargs=1;
 end
end
%
if ~exist([arg1,'.mat'])
 disp([' **** error: ',arg1,'.mat does not exist']), return
end
[z,p,k,str]=exportf(arg1,1); if isempty(k), return, end
xz1=real(z); yz1=imag(z); xp1=real(p); yp1=imag(p);
zp=[z;p]; xxx=real(zp); yyy=imag(zp);
if islegen
 LABLEG=['''',arg1,''''];
end
%
if nargs>=2
 if ~exist([arg2,'.mat'])
  disp([' **** error: ',arg2,'.mat does not exist']), return
 end
 [z,p,k,str1]=exportf(arg2,1); if isempty(k), return, end
 xz2=real(z); yz2=imag(z); xp2=real(p); yp2=imag(p);
 zp=[z;p]; xxx=[xxx;real(zp)]; yyy=[yyy;imag(zp)];
 if str1~=str
  disp(' **** error: mixed continuous and discrete time'), return
 end
 if islegen
  LABLEG=[LABLEG,',''',arg2,''''];
 end
end
if nargs>=3
 if ~exist([arg3,'.mat'])
  disp([' **** error: ',arg3,'.mat does not exist']), return
 end
 [z,p,k,str1]=exportf(arg3,1); if isempty(k), return, end
 zp=[z;p];
 xz3=real(z); yz3=imag(z); xp3=real(p); yp3=imag(p);
 zp=[z;p]; xxx=[xxx;real(zp)]; yyy=[yyy;imag(zp)];
 if str1~=str
  disp(' **** error: mixed continuous and discrete time'), return
 end
 if islegen
  LABLEG=[LABLEG,',''',arg3,''''];
 end
end
if nargs>=4
 if ~exist([arg4,'.mat'])
  disp([' **** error: ',arg4,'.mat does not exist']), return
 end
 [z,p,k,str1]=exportf(arg4,1); if isempty(k), return, end
 xz4=real(z); yz4=imag(z); xp4=real(p); yp4=imag(p);
 zp=[z;p]; xxx=[xxx;real(zp)]; yyy=[yyy;imag(zp)];
 if str1~=str
  disp(' **** error: mixed continuous and discrete time'), return
 end
 if islegen
  LABLEG=[LABLEG,',''',arg4,''''];
 end
end
%
xi=min(xxx); xs=max(xxx); yi=min(yyy); ys=max(yyy);
dx=(xs-xi)*frame; dy=(ys-yi)*frame;
xi=xi-dx;xs=xs+dx;yi=yi-dy;ys=ys+dy;
%
clf, ordf(3), nfig=gcf; nfigs=int2str(nfig); FIGLO=resfiglo;
FIGLEG=nfig;
if any(FIGLO(10,:))
 erx=0; eval('set(nfig,''Position'',FIGLO(10,1:4))','erx=1;')
end
men_opt=uimenu(nfig,'Label','Recall');
if strcmp(str,'s')
 mess='zero-pole map, continuous time';
else
 mess='zero-pole map, discrete time';
end
uimenu(men_opt,'Label',mess);
plot([xi,xi,xs,xs],[yi,ys,ys,yi],'Color',vcol1(8,:),'LineStyle','.')
VV=axis; axis(VV), hold on
%
if ~isempty(xz1)
 plot(xz1,yz1,'Color',vcol1(1,:),'LineStyle','o','LineWidth',2)
end
if ~isempty(xp1)
 plot(xp1,yp1,'Color',vcol1(1,:),'LineStyle','x','LineWidth',2)
end
TRF1=[arg1,repco(1)];
uimenu(men_opt,'Label',[arg1,', color ',repco(1)],'Separator','on',...
'Callback','tfmaux(1,1,0)');
if nargs>=2
 if ~isempty(xz2)
  plot(xz2,yz2,'Color',vcol1(2,:),'LineStyle','o','LineWidth',2)
 end
 if ~isempty(xp2)
  plot(xp2,yp2,'Color',vcol1(2,:),'LineStyle','x','LineWidth',2)
 end
 TRF2=[arg2,repco(2)];
 uimenu(men_opt,'Label',[arg2,', color ',repco(2)],...
 'Callback','tfmaux(2,1,0)');
end
if nargs>=3
 if ~isempty(xz3)
  plot(xz3,yz3,'Color',vcol1(3,:),'LineStyle','o','LineWidth',2)
 end
 if ~isempty(xp3)
  plot(xp3,yp3,'Color',vcol1(3,:),'LineStyle','x','LineWidth',2)
 end
 TRF3=[arg3,repco(3)];
 uimenu(men_opt,'Label',[arg3,', color ',repco(3)],...
 'Callback','tfmaux(3,1,0)');
end
if nargs>=4
 if ~isempty(xz4)
  plot(xz4,yz4,'Color',vcol1(4,:),'LineStyle','o','LineWidth',2)
 end
 if ~isempty(xp4)
  plot(xp4,yp4,'Color',vcol1(4,:),'LineStyle','x','LineWidth',2)
 end
 TRF4=[arg4,repco(4)];
 uimenu(men_opt,'Label',[arg4,', color ',repco(4)],...
 'Callback','tfmaux(4,1,0)');
end
if strcmp(str,'s')
 plot([0,0],[VV(3),VV(4)],'Color',vcol1(7,:),'LineStyle',':')
 plot([VV(1),VV(2)],[0,0],'Color',vcol1(7,:),'LineStyle',':')
else
 ang=2*pi*linspace(0,1,400); circ=cos(ang)+j*sin(ang);
 plot(circ,'Color',vcol1(7,:),'LineStyle',':')
 plot([0,0],[VV(3),VV(4)],'Color',vcol1(7,:),'LineStyle',':')
 plot([VV(1),VV(2)],[0,0],'Color',vcol1(7,:),'LineStyle',':')
end
men_gr=uimenu(nfig,'Label','Grids');
uimenu(men_gr,'Label','Grid on/off','Callback','grid');
uimenu(men_gr,'Label','Constant damping loci on/off','Callback','gridmng(5)');
men_zoom=uimenu(nfig,'Label','Zoom on/off','Callback','rootlaux(2)');
if islegen
 for kk=1:nargs
  ha=plot(0,0,'Color',vcol1(kk,:),'LineStyle','-');
  HALEG=[HALEG;ha];
 end
end
if legen==1, eval(['legend(HALEG,',LABLEG,')']), end
figure(nfig), hold off, ABIL=1;
xyx=input(['   **** figure ',nfigs,' **** '],'s');
cc=get(0,'Children');
if any(cc==nfig)
 FIGLO(10,1:4)=get(nfig,'Position');
 save figlo# FIGLO
 zoom off, zoom out
else
 disp(' '), disp('   THE FIGURE HAS BEEN DELETED!'), figure, ordf(1)
end
if length(HA)>0
 for kk=1:length(HA), eval('delete(HA(kk))','err=1;'), end
 HA=[]; gridmng(5)
end
eval('delete(men_gr)','err=1;'), eval('delete(men_zoom)','err=1;'), ordf(1)
% --- last line of zpplots ---
