function firtf(arg1,arg2,arg3,arg4)
%FIRTF	  Creazione di un FIR - finite-impulse-response system (TFI).
%    FIRTF,gi,gj - da TFI [FIRTF('gi','gj') - da Matlab] crea un FIR
%    gj dalla funzione di trasferimento gi,
%    La lunghezza del FIR e' specificata in interattivo.
%    Se FIRSP viene chiamato senza alcun argomento, le f.d.t. gi e gj
%    possono essere specificate in modo interattivo.

% TFI Environment (A.Civolani & G.Marro) - 1994-96.

if nargin==0
 flg=0;
 while flg==0
  gi=input('   funzione di trasferimento gi (ingresso) : ','s');
  if ~isempty(gi)
   if ~exist([gi,'.mat'])
    disp([' **** errore: ',gi,'.mat non esiste'])
   else
    flg=1;
   end
  end
 end
 while flg==1
  gj=input('   funzione di trasferimento gj (uscita) : ','s');
  if ~isempty(gj)
   flg=2;
  end
 end
elseif nargin>=2
 if ~exist([arg1,'.mat'])
  disp([' **** errore: ',arg1,'.mat non esiste']), return
 else
  gi=arg1; gj=arg2;
 end
else
 disp(' **** errore: numero di argomenti non sufficiente'), return
end
[num,den,str]=exportf(gi,1); % if isempty(den), return, end
if str=='s'
 disp(' **** errore: sistema a tempo continuo'), return
end
tfg(gi)
N=input('   specifica la lunghezza del FIR : ');
k1=abs(N);
%
k0=0; k=k0:1:k1; nk=length(k);
%
ttt=[zeros(1,length(den)-length(num)),num];
y=filter(ttt,den,[1,zeros(1,nk-1)]);
%
num1=y;
den1=[1,zeros(1,k1)];
aa=importf(num1,den1,gj,1);
if aa==1, tfg(gj), end
% --- last line of firtf ---
