function out1=startint(arg1)
%STARTINT Impostazione di opzioni relative all'ambiente TFI (TFI).
%   STARTINT puo' essere chiamato da Matlab o TFI per la scelta interattiva
%   di impostazioni di TFI. Le impostazioni scelte vengono salvate nel file
%   set_tfi#.mat nelle directory di lavoro sia di Matlab che di TFI.

%   STARTINT(1) viene eseguito quando si entra nell'ambiente TFI.
%   STARTINT(2) viene eseguito quando si lascia l'ambiente TFI.

% TFI Environment (A.Civolani & G.Marro) - 1994-96.

aA=setstr(224); eA=setstr(232); oA=setstr(242); EA=setstr(200);
nargs=nargin; err=0; flg=0;
mmm=' **** premere un tasto per proseguire';
colbg=get(0,'DefaultFigureColor');
if nargs==0, arg1=3; end
if (nargs==1)&(arg1==1)
%
% some TFI settings
%
 POS=get(0,'DefaultFigurePosition');
 VVFULL=get(0,'ScreenSize'); % VVFULL is a [1 times 4] matrix
 XL=VVFULL(3); YL=VVFULL(4); XS=229; YS=137; % small figure size
 VVS=round([XL*.92-XS,YL-YS-50,XS,YS]);
 set(0,'DefaultFigurePosition',VVS)
 set(0,'DefaultTextFontName','Helvetica')
 set(0,'DefaultTextFontSize',11)
 set(0,'DefaultTextFontWeight','normal')
 set(0,'DefaultAxesFontName','Helvetica')
 set(0,'DefaultAxesFontSize',11)
 set(0,'DefaultAxesFontWeight','normal')
 delf
%
% the following lines change directory and/or path when tfi is entered
%
 diro=cd; dirn=diro; patho=path; pathn=[]; legen=0; ispath=0; bgkkk=1; mfig=0;
 if exist('set_tfi#.mat')
  load set_tfi#
  if colbg(1)~=bgkkk, whitebg, end
  s1=cd; flg=1; patho=path;
  pathf=[patho,';'];
  if ispath
   for kk=1:(length(pathf)-5)
    stt=pathf(kk:kk+5);
    if stt(1:5)=='\intp'
     if stt(6)==';'
      ddd1='\intp';
     else
      ddd1=['\intp',stt(6)];
     end
     break
    end
   end
   pathf=pathn;
   ii=find(pathf=='\'); iif=ii(length(ii));
   pathn=[pathf(1:iif-1),ddd1];
  else
   pathn=[];
  end
  aa=abs([s1(1),diro(1),dirn(1)]);
  if aa(3)==92, aa(3)=aa(1); dirn=[s1(1),':',dirn]; end
  ii=find(aa<97);
  if ~isempty(ii), aa(ii)=aa(ii)+32*ones(1,length(ii)); end
  aa=setstr(aa);
  if aa(1)~=aa(2)
   delete set_tfi#.mat
   diro=cd; dirn=diro; pathn=[]; legen=0; ispath=0;
   disp(' ')
   disp(['   **** unit',aA,' disco non valida !'])
   disp(['   **** verr',aA,' ripristinata l''impostazione di default di TFI'])
  end
  cs=abs(s1); ii=find((cs>=65)&(cs<=90)); cs(ii)=cs(ii)+32; cmp1=setstr(cs);
  cs=abs(diro); ii=find((cs>=65)&(cs<=90)); cs(ii)=cs(ii)+32; cmp2=setstr(cs);
  cs=abs(dirn); ii=find((cs>=65)&(cs<=90)); cs(ii)=cs(ii)+32; cmp3=setstr(cs);
  if (~strcmp(cmp1,cmp2))&(~strcmp(cmp1,cmp3))
  flg=0;
   disp(' ')
   disp(['   **** la directory di lavoro di Matlab ',eA,' stata cambiata !'])
  end
 else % if exist
  whitebg([1,1,1]) % the default initial color (white)
  bgkkk=1;
  disp(' '), fltt=0; 
  while fltt==0
   disp([' **** il file set_tfi#.mat non ',eA,' stato trovato'])
   disp(['      la directory di lavoro corrente ',eA,' : ',cd])
   fprintf('      la volete confermare come una directory')
   xyx=input('      dalla quale si possa chiamere TFI ? (1/0) : ');
   if ~isempty(xyx), fltt=1; end
  end
  if xyx~=1, out1=1; return, end
 end
 if exist('legend.m'), islegen=1; else, islegen=0; end
 if flg==1
  save set_tfi# diro dirn patho pathn legen islegen ispath bgkkk POS mfig
 end
 eval(['cd ',dirn],'err=1;')
 if err==0
  dirn=cd;
  save set_tfi# diro dirn patho pathn legen islegen ispath bgkkk POS mfig
 end
 if mfig==0, eval('resfiglo'), end
 save legen# legen islegen
 if ispath, path(pathn), end
 disp(' ')
 disp('   INFORMAZIONI SULL''AMBIENTE TFI :')
 disp(' ')
 disp(['   la directory di lavoro di Matlab ',eA,' ',diro])
 disp(['   la directory di lavoro di TFI ',eA,'    ',dirn])
 if err==1
  disp(' ')
  disp('   **** directory di lavoro di TFI non valida !')
  disp(['   **** verr',aA,' ripristinata l''impostazione di default di TFI'])
  diro=cd; dirn=diro; patho=path; pathn=[]; legen=0; ispath=0;
  save set_tfi# diro dirn patho pathn legen islegen ispath bgkkk POS mfig
 else
  if ispath==0, ll='NON '; else, ll=''; end
  disp(['   il matlabpath ',ll,EA,' RIDOTTO'])
  if bgkkk==1, ll='BIANCO'; else, ll='NERO'; end
  disp(['   lo sfondo delle figure ',EA,' ',ll])
  if mfig==0, ll=' NON '; else, ll=' '; end
  disp(['   le posizioni delle figure',ll,'SONO MEMORIZZATE'])
  if exist('legend.m')
   if legen==1, ll=''; else, ll='NON '; end
   disp(['   la legenda nelle figure ',ll,EA,' ATTIVATA'])
  end
  disp(' ')
  disp('   usare "startint" da TFI per cambiare tali impostazioni')
 end
 disp(' '), disp(mmm), pause
 if ~exist('time#.mat'), samptime(.1), end
 if ~exist('figlo#.mat'), resfiglo, end
%
% the following lines restore directory and/or path when tfi is quitted
%
elseif (nargs==1)&(arg1==2)
 set(0,'DefaultUiControlUnits','pixel')
 if exist('set_tfi#.mat')
  load set_tfi#
  set(0,'DefaultFigurePosition',POS)
  % eval(['cd ',diro],'err=1;')
  eval(['cd ',dirn],'err=1;') % mofifica Dicembre 2014
  if err==0
   disp(' ')
   disp(['   ',eA,' stata ripristinata la directory di lavoro di Matlab: ',cd])
   save set_tfi# diro dirn patho pathn legen islegen ispath bgkkk POS mfig
  else
   delete set_tfi#.mat
  end
  if ispath==1
   path(patho)
   % path(pathn) % mofifica Dicembre 2014
   disp(' ')
   disp(['   ',eA,' stato ripristinato il matlabpath completo'])
  end
 end
end
%
% interactive selection of directory, path, and legend
%
if arg1==3
 if exist('set_tfi#.mat')
  load set_tfi#
  disp(' ')
  disp(['   TFI ',eA,' stato chiamato da e torner',aA,' a    ',diro])
  disp(['   l''attuale directory di lavoro di TFI ',eA,' ',dirn])
  flg=0;
  while flg==0
   err=0;
   fprintf('   per cambiare la directory di lavoro di TFI,')
   fprintf(' specificare il path')
   mess='   (default "non cambiare") : ';
   dd=input(mess,'s');
   if length(dd)==0
    flg=1;
   else
    dirt=dd;
    eval(['cd ',dirt],'err=1;')
    if err==1
     disp('   la directory non esiste')
    else
     flg=1; dirn=cd;
    end % if err
   end % if length
  end % while
  disp(' ')
  fprintf(['   si pu',oA,' ridurre il matlabpath per evitare conflitti'])
  fprintf(' di nomi\n')
  fprintf('   con nuovi toolbox;')
  if ispath==0, ll='NON '; else, ll=''; end
  fprintf([' ora il matlabpath ',ll,EA,' RIDOTTO'])
  rl=0;
  while rl==0
   mess='   volete ridurre il matlabpath ? (1/0, ';
   mess=[mess,'default "non cambiare") : '];
   dd=input(mess);
   if (dd==0)|(dd==1)|(length(dd)==0), rl=1; end
  end
  if length(dd)==1, flg=dd; else, flg=3; end
  if flg==1
%
% the following lines set the matlabpath when the interpreter is invoked
% ---> list here the names of the needed toolboxes
%
   bb1='\local';
   bb2='\general';
   bb3='\ops';
   bb4='\lang';
   bb5='\elmat';
   bb6='\elfun';
   bb7='\specfun';
   bb8='\matfun';
   bb9='\datafun';
   bb10='\polyfun';
   bb11='\sparfun';
   bb12='\plotxy';
   bb13='\plotxyz';
   bb14='\graphics';
   bb15='\strfun';
%
   bb16='\intp';
%
   pathf=patho;
   if ~strcmp(pathf(length(pathf)),';'), pathf=[pathf,';']; end
   ii=find(pathf==';');
   rr=0;
   nbox=0;
   while rr==0
    nbox=nbox+1;
    if ~exist(['bb',int2str(nbox)])
     rr=1; nbox=nbox-1;
    end
   end % while rr
%   intt=pathf(1:ii(1)); pathn=intt;
   pathn=[];
   for hh=1:nbox
    bb=eval(['bb',int2str(hh)]);
    rr=0;
    for kk=1:length(ii)
     cc=pathf((ii(kk)-length(bb)):(ii(kk)-1));
     if strcmp(bb,'\intp')
      cc1=pathf((ii(kk)-length(bb)-1):(ii(kk)-1));
      cc1=cc1(1:length(bb));
     else
      cc1='xxx';
     end
     if strcmp(cc,bb)|strcmp(cc1,bb)
      if kk==1, ind1=1; else, ind1=ii(kk-1)+1; end
      aa=pathf(ind1:ii(kk)); pathn=[pathn,aa]; rr=1; break
     end
    end % for kk
   end % for hh
   disp(' ')
   if rr==0
    disp(['   il toolbox ',bb,' non ',eA,' stato trovato nel matlabpath;'])
    disp('   controllare la lista delle directory nel file startint.m')
    disp(' '), disp(mmm), pause
    pathn=[]; ispath=0;
   else
    fprintf(['   il matlabpath ',eA,' stato ridotto per evitare conflitti di'])
    fprintf(' nomi con nuovi\n')
    fprintf(['   toolbox; esso sar',aA,' ripristinato all''uscita da TFI\n'])
    path(pathn), ispath=1;
   end
  elseif flg==0
   path(patho), pathn=[]; ispath=0;
  end % if flg
  disp(' ')
  if bgkkk==1, ll='BIANCO'; else, ll='NERO'; end
  fprintf(['   ora lo sfondo delle figure ',EA,' ',ll])
  rl=0;
  while rl==0
   mess='   sfondo nero o bianco ? (1/0, default "non cambiare") : ';
   dd=input(mess);
   if isempty(dd), dd=20; rl=1; end
   if (dd==0)|(dd==1), bgkkk=~dd; rl=1; end
  end
  whitebg([1 1 1]*(bgkkk))
  disp(' ')
  if mfig==1, ll=''; else, ll='NON '; end
  fprintf(['   le posizioni delle figure ',ll,'SONO MEMORIZZATE'])
  fprintf(' in modo permanente')
  rl=0;
  while rl==0
   mess='   le volete memorizzare ? ';
   mess=[mess,'(1/0, default "non cambiare") : '];
   dd=input(mess);
   if isempty(dd), dd=20; rl=1; end
   if (dd==0)|(dd==1), mfig=dd; rl=1; end
  end
  if exist('legend.m')
   disp(' ')
   if legen==1, ll=''; else, ll='NON '; end
   fprintf(['   ora la legenda nelle figure ',ll,EA,' ATTIVATA'])
   rl=0;
   while rl==0
    mess='   volete la legenda nelle figure ? ';
    mess=[mess,'(1/0, default "non cambiare") : '];
    dd=input(mess);
    if (dd==0)|(dd==1)|(length(dd)==0), rl=1; end
   end
   if length(dd)==1, legen=dd; end
  end % if exist('legend.m')
  save legen# legen islegen
  save set_tfi# diro dirn patho pathn legen islegen ispath bgkkk POS mfig
  if ~exist('time#.mat')
   eval('samptime')
  end
  if ~strcmp(diro,dirn)
   dircurr=cd;
   if ~strcmp(dircurr,diro)
    err=0; eval(['cd ',diro],'err=1;')
    if err==0
     save set_tfi# diro dirn patho pathn legen islegen ispath bgkkk POS mfig
    end
   elseif ~strcmp(dircurr,dirn)
    err=0; eval(['cd ',dirn],'err=1;')
    if err==0
     save set_tfi# diro dirn patho pathn legen islegen ispath bgkkk POS mfig
    end
   end
   eval(['cd ',dircurr],'err=1;')
  end
 else
  disp(' ')
  disp('   il file set_tfi#.mat non esiste')
  disp('   entrare di nuovo in TFI per attivare le impostazioni di default')
  disp('   quindi avviare "startint"')
  disp(' ')
 end % if exist('set_tfi.mat')
end % if arg1
% ----- last line of startint -----
